- [HTTP request](https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.agent.sessions/detectIntent#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.agent.sessions/detectIntent#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.agent.sessions/detectIntent#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.agent.sessions/detectIntent#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.agent.sessions/detectIntent#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.agent.sessions/detectIntent#body.aspect)
- [Try it!](https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.agent.sessions/detectIntent#try-it)

Processes a natural language query and returns structured, actionable data as a result. This method is not idempotent, because it may cause contexts and session entity types to be updated, which in turn might affect results of future queries.

If you might use [Agent Assist](https://cloud.google.com/dialogflow/docs/#aa) or other CCAI products now or in the future, consider using `https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.conversations.participants/analyzeContent#google.cloud.dialogflow.v2.Participants.AnalyzeContent` instead of `sessions.detectIntent`. `AnalyzeContent` has additional functionality for Agent Assist and other CCAI products.

Note: Always use agent versions for production traffic. See [Versions and environments](https://cloud.google.com/dialogflow/es/docs/agents-versions).

### HTTP request

Choose an endpoint:
global   
`POST https://dialogflow.googleapis.com/v2/{session=projects/*/agent/sessions/*}:detectIntent`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

**OR**

`POST https://{endpoint}/v2/{session=projects/*/agent/sessions/*}:detectIntent`

Where `{endpoint}` is one of the [supported service endpoints](https://docs.cloud.google.com/dialogflow/es/docs/reference/rest#rest_endpoints).

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `session` | `string` Required. The name of the session this query is sent to. Format: `projects/<Project ID>/agent/sessions/<Session ID>`, or `projects/<Project ID>/agent/environments/<Environment ID>/users/<User ID>/sessions/<Session ID>`. If `Environment ID` is not specified, we assume default 'draft' environment (`Environment ID` might be referred to as environment name at some places). If `User ID` is not specified, we are using "-". It's up to the API caller to choose an appropriate `Session ID` and `User Id`. They can be a random number or some type of user and session identifiers (preferably hashed). The length of the `Session ID` and `User ID` must not exceed 36 characters. For more information, see the [API interactions guide](https://cloud.google.com/dialogflow/docs/api-overview). Note: Always use agent versions for production traffic. See [Versions and environments](https://cloud.google.com/dialogflow/es/docs/agents-versions). Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `session`: - `dialogflow.sessions.detectIntent` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "queryParams": { object (`https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/QueryParameters`) }, "queryInput": { object (`https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/QueryInput`) }, "outputAudioConfig": { object (`https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/OutputAudioConfig`) }, "outputAudioConfigMask": string, "inputAudio": string } ``` |

| Fields ||
|---|---|
| `queryParams` | ``object (`https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/QueryParameters`)`` The parameters of this query. |
| `queryInput` | ``object (`https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/QueryInput`)`` Required. The input specification. It can be set to: 1. an audio config which instructs the speech recognizer how to process the speech audio, 2. a conversational query in the form of text, or 3. an event that specifies which intent to trigger. |
| `outputAudioConfig` | ``object (`https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/OutputAudioConfig`)`` Instructs the speech synthesizer how to generate the output audio. If this field is not set and agent-level speech synthesizer is not configured, no output audio is generated. |
| `outputAudioConfigMask` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#field-mask` format)`` Mask for `https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.agent.sessions/detectIntent#body.request_body.FIELDS.output_audio_config` indicating which settings in this request-level config should override speech synthesizer settings defined at agent-level. If unspecified or empty, `https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/projects.agent.sessions/detectIntent#body.request_body.FIELDS.output_audio_config` replaces the agent-level config in its entirety. This is a comma-separated list of fully qualified names of fields. Example: `"user.displayName,photo"`. |
| `inputAudio` | `string (https://developers.google.com/discovery/v1/type-format format)` The natural language speech audio to be processed. This field should be populated iff `queryInput` is set to an input audio config. A single request can contain up to 1 minute of speech audio data. A base64-encoded string. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/dialogflow/es/docs/reference/rest/v2/DetectIntentResponse`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `
  https://www.googleapis.com/auth/dialogflow`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).